xpmonitor_history = {}
xpmonitor_startTime = 0
xpmonitor_startXP = 0
xpmonitor_lastXP = 0
xpmonitor_lastMaxXP = 0
xpmonitor_gainedXPAllTime = 0
xpmonitor_xpPerMin = 0
xpmonitor_perSecondXP = 0
xpmonitor_xpPerHour = 0
xpmonitor_updateInterval = 1.0
xpmonitor_isTimerStarted = false
xpmonitor_playedTimeAllTime = 0
xpmonitor_stopTime = 0
xpmonitor_hasPausedOnce = false
xpmonitor_lastNeedleDegree = 27
xpmonitor_timeSinceLastUpdate = 0
xpmonitor_gainedXP = 0
xpmonitor_estMinToNextLevel = 0
xpmonitor_nextLevelMin = 0

function xpmonitor_onLoad()
    xpmonitor_timeSinceLastUpdate = 0

    xpmonitor_changeSize()
    xpmonitor_mainFrame:SetScript("OnUpdate", xpmonitor_onUpdate)
    xpmonitor_mainFrame:RegisterEvent("PLAYER_MONEY")
    xpmonitor_mainFrame:RegisterEvent("CURRENT_SPELL_CAST_CHANGED")
    xpmonitor_mainFrame:RegisterEvent("TIME_PLAYED_MSG")

    xpmonitor_rotateTexture(xpmonitor_mainFrame_nadelTexture, xpmonitor_lastNeedleDegree)
end

function xpmonitor_onMouseDown()
    xpmonitor_mainFrame:StartMoving()
end

function xpmonitor_onMouseUp()
    xpmonitor_mainFrame:StopMovingOrSizing()
end

function xpmonitor_changeSize()
    local width = 210
    local height = 170

    xpmonitor_mainFrame:SetWidth(width)
    xpmonitor_mainFrame:SetHeight(height)
end

function xpmonitor_buttonStartMonitor_onClick()
    if not xpmonitor_isTimerStarted then
        xpmonitor_startTime = GetTime()
        xpmonitor_startXP = UnitXP("player")
        xpmonitor_lastXP = UnitXP("player")
        xpmonitor_lastMaxXP = UnitXPMax("player")
        xpmonitor_isTimerStarted = true
        xpmonitor_mainFrame_expPerMinuteLabel:SetTextColor(0,1,0,1)
        xpmonitor_mainFrame_expPerMinuteLabel:SetFont("GameFontNormal", 100)
        xpmonitor_mainFrame_expPerHourLabel:SetTextColor(0,1,0,1)
        xpmonitor_mainFrame_expPerHourLabel:SetFont("GameFontNormal", 100)
        xpmonitor_mainFrame_estMinToNextLevelLabel:SetTextColor(0,1,0,1)
        xpmonitor_mainFrame_nextLevelMinLabel:SetTextColor(0,1,0,1)
        DEFAULT_CHAT_FRAME:AddMessage("XP-Monitor started")
    end
end

function xpmonitor_buttonStopMonitor_onClick()
    if xpmonitor_isTimerStarted then
        xpmonitor_playedTimeAllTime = xpmonitor_playedTimeAllTime + (GetTime() - xpmonitor_startTime)
        local playedTimeHours = floor(xpmonitor_playedTimeAllTime / 3600)
        local playedTimeMinutes = floor((xpmonitor_playedTimeAllTime - (playedTimeHours * 3600)) / 60)
        local playedTimeSeconds = xpmonitor_playedTimeAllTime - (playedTimeHours * 3600) -  (playedTimeMinutes * 60)

        DEFAULT_CHAT_FRAME:AddMessage("You played: " .. playedTimeHours .. " h "
                                                     .. playedTimeMinutes .. " min "
                                                     .. playedTimeSeconds .. " sec")
        DEFAULT_CHAT_FRAME:AddMessage("You gained: " .. xpmonitor_gainedXPAllTime .. " EXP")

        xpmonitor_isTimerStarted = false
        xpmonitor_mainFrame_expPerMinuteLabel:SetTextColor(1,0,0,1)
        xpmonitor_mainFrame_expPerHourLabel:SetTextColor(1,0,0,1)
        xpmonitor_mainFrame_estMinToNextLevelLabel:SetTextColor(1,0,0,1)
        xpmonitor_mainFrame_nextLevelMinLabel:SetTextColor(1,0,0,1)
        xpmonitor_hasPausedOnce = true
        DEFAULT_CHAT_FRAME:AddMessage("XP-Monitor stoped")
    end
end

function xpmonitor_buttonResetMonitor_onClick()
    xpmonitor_startTime = 0
    xpmonitor_startXP = 0
    xpmonitor_lastXP = 0
    xpmonitor_lastMaxXP = 0
    xpmonitor_gainedXPAllTime = 0
    xpmonitor_perSecondXP = 0
    xpmonitor_updateInterval = 1.0
    xpmonitor_isTimerStarted = false
    xpmonitor_playedTimeAllTime = 0
    xpmonitor_stopTime = 0
    xpmonitor_hasPausedOnce = false
    xpmonitor_estMinToNextLevel = 0
    xpmonitor_nextLevelMin = 0
    xpmonitor_xpPerHour = 0
    DEFAULT_CHAT_FRAME:AddMessage("|cFFFF0000Data reseted!|r")

    xpmonitor_mainFrame_expPerMinuteLabel:SetText("XP/Min: 0")
    xpmonitor_mainFrame_expPerMinuteLabel:SetTextColor(1,0,0,1)
    xpmonitor_mainFrame_expPerHourLabel:SetText("XP/Hour: 0")
    xpmonitor_mainFrame_expPerHourLabel:SetTextColor(1,0,0,1)
    xpmonitor_mainFrame_estMinToNextLevelLabel:SetText("Avg. lvl up ~ 0.00 Min")
    xpmonitor_mainFrame_estMinToNextLevelLabel:SetTextColor(1,0,0,1)
    xpmonitor_mainFrame_nextLevelMinLabel:SetText("Lvl up in 0.00 Min")
    xpmonitor_mainFrame_nextLevelMinLabel:SetTextColor(1,0,0,1)
    xpmonitor_rotateTexture(xpmonitor_mainFrame_nadelTexture, 27)
    xpmonitor_changeSize()
end

function xpmonitor_onEvent(self, event, ...)
    if event == "PLAYER_MONEY" then
        -- nothing
    elseif event == "CURRENT_SPELL_CAST_CHANGED" then
        -- nothing
    elseif event == "TIME_PLAYED_MSG" then
        -- nothing
    end
end

function xpmonitor_onUpdate(self, elapsed)
    xpmonitor_timeSinceLastUpdate = xpmonitor_timeSinceLastUpdate + elapsed
    if (xpmonitor_timeSinceLastUpdate > xpmonitor_updateInterval) then
        xpmonitor_gainedXP = 0
        if (xpmonitor_isTimerStarted) then
            -- true if still same level --
            if (xpmonitor_lastMaxXP == UnitXPMax("player")) then
                xpmonitor_gainedXP = UnitXP("player") - xpmonitor_lastXP
                xpmonitor_estMinToNextLevel = (UnitXPMax("player") / xpmonitor_xpPerMin)
                xpmonitor_nextLevelMin = ((UnitXPMax("player") - UnitXP("player")) / xpmonitor_xpPerMin)
            elseif (xpmonitor_lastMaxXP < UnitXPMax("player")) then
                local diffToLevelUp = xpmonitor_lastMaxXP - xpmonitor_lastXP
                xpmonitor_gainedXP = diffToLevelUp + (UnitXP("player"))
            end

            xpmonitor_lastMaxXP = UnitXPMax("player")
            xpmonitor_lastXP = UnitXP("player")
            xpmonitor_gainedXPAllTime = xpmonitor_gainedXPAllTime + xpmonitor_gainedXP

            if not (xpmonitor_hasPausedOnce) then
                xpmonitor_xpPerMin = xpmonitor_gainedXPAllTime / ((GetTime() - xpmonitor_startTime) / 60)
                xpmonitor_xpPerHour = (xpmonitor_xpPerMin * 60)
            else
                xpmonitor_xpPerMin = xpmonitor_gainedXPAllTime / (((GetTime() - xpmonitor_startTime) + xpmonitor_playedTimeAllTime) / 60)
                xpmonitor_xpPerHour = (xpmonitor_xpPerMin * 60)
            end
            xpmonitor_mainFrame_expPerMinuteLabel:SetText("XP/Min: " .. xpmonitor_roundValue(xpmonitor_xpPerMin, 2))
            xpmonitor_mainFrame_expPerHourLabel:SetText("XP/Hour: " .. xpmonitor_roundValue(xpmonitor_xpPerHour, 2))
            xpmonitor_mainFrame_estMinToNextLevelLabel:SetText("Avg. lvl up ~ " .. xpmonitor_roundValue(xpmonitor_estMinToNextLevel, 2) .. " Min")

            -- next level time
            xpmonitor_mainFrame_nextLevelMinLabel:SetText("Lvl up in " .. xpmonitor_roundValue(xpmonitor_nextLevelMin, 2) .. " Min")

            xpmonitor_changeSize()
        else

        end
        xpmonitor_timeSinceLastUpdate = 0
    end
    if (xpmonitor_isTimerStarted) then
        xpmonitor_lastNeedleDegree = ((xpmonitor_xpPerMin / 4.27) * -1) + 27
        xpmonitor_rotateTexture(xpmonitor_mainFrame_nadelTexture, xpmonitor_lastNeedleDegree)
    end
end

function xpmonitor_roundValue(num, numDecimals)
    local mult = 10^(numDecimals or 0)
    return math.floor(num * mult + 0.5) / mult
end

function xpmonitor_calculateCorner(angle)
    local s2 = sqrt(2);
    local cos, sin, rad = math.cos, math.sin, math.rad;
	local r = rad(angle);
	return 0.5 + cos(r) / s2, 0.5 + sin(r) / s2;
end

function xpmonitor_rotateTexture(texture, angle)
	local LRx, LRy = xpmonitor_calculateCorner(angle + 45);
	local LLx, LLy = xpmonitor_calculateCorner(angle + 135);
	local ULx, ULy = xpmonitor_calculateCorner(angle + 225);
	local URx, URy = xpmonitor_calculateCorner(angle - 45);
	
	texture:SetTexCoord(ULx, ULy, LLx, LLy, URx, URy, LRx, LRy);
end

